unit Data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mtrClient, mtrServer, mtrCustomServers, Db, DBTables;

type
  TdmMain = class(TDataModule)
    Database: TDatabase;
    mtrBDEServer: TmtrBDEServer;
    mtrClient: TmtrClient;
    procedure mtrClientPrintBand(const AMax, ACurrent: Integer;
      var AFinish: Boolean);
    procedure mtrClientAfterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Connect(APath: string);
    procedure Disconnect;
    procedure ShowAbout;
  end;

var
  dmMain: TdmMain;

implementation

uses About, Progress;

{$R *.DFM}

{ TdmMain }

procedure TdmMain.Connect(APath: string);
begin
  Database.Open;
end;

procedure TdmMain.Disconnect;
begin
  Database.Close;
end;

procedure TdmMain.ShowAbout;
begin
  fmAbout.ShowModal;
end;

procedure TdmMain.mtrClientPrintBand(const AMax, ACurrent: Integer;
  var AFinish: Boolean);
begin
  with fmProgress do begin
    ProgressBar.Max := AMax;
    ProgressBar.Position := ACurrent;
    if not Visible then begin
      Show;
      SetFocus;
    end;
    Application.ProcessMessages;
    AFinish := Cancel;
    Cancel := false;
  end;
end;

procedure TdmMain.mtrClientAfterExecute(Sender: TObject);
begin
  if fmProgress.Visible then fmProgress.Close;
end;

end.
