unit Data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ServerBDE_TLB, mtrClient, mtrGlobal;

type
  TdmMain = class(TDataModule)
    mtrClient: TmtrClient;
    procedure mtrClientGetData(ADataStream: TMemoryStream);
    procedure mtrClientGetSchemaData(ADataStream: TMemoryStream);
    procedure mtrClientPrintBand(const AMax, ACurrent: Integer;
      var AFinish: Boolean);
    procedure mtrClientAfterExecute(Sender: TObject);
  private
    { Private declarations }
    FServerIntf: IReportServer;
  public
    { Public declarations }
    procedure Connect(APath: string);
    procedure Disconnect;
    procedure ShowAbout;
  end;

var
  dmMain: TdmMain;

implementation

uses About, Progress;

{$R *.DFM}

procedure TdmMain.Connect(APath: string);
var
  server_machine: string;
begin
  server_machine := 'localhost';
  if InputQuery('Input', 'Server Machine Name', server_machine) then
    FServerIntf := CoReportServer.CreateRemote(server_machine)
  else
    Abort;
end;

procedure TdmMain.Disconnect;
begin
  FServerIntf := nil;
end;

procedure TdmMain.mtrClientGetData(ADataStream: TMemoryStream);
var
  value: OleVariant;
begin
  value := mtrGlobal.MemoryStream2OleVariant(ADataStream);
  FServerIntf.Execute(value);
  mtrGlobal.OleVariant2MemoryStream(value, ADataStream);
end;

procedure TdmMain.mtrClientGetSchemaData(ADataStream: TMemoryStream);
var
  value: OleVariant;
begin
  value := mtrGlobal.MemoryStream2OleVariant(ADataStream);
  FServerIntf.Prepare(value);
  mtrGlobal.OleVariant2MemoryStream(value, ADataStream);
end;

procedure TdmMain.ShowAbout;
begin
  fmAbout.ShowModal;
end;

procedure TdmMain.mtrClientPrintBand(const AMax, ACurrent: Integer;
  var AFinish: Boolean);
begin
  with fmProgress do begin
    ProgressBar.Max := AMax;
    ProgressBar.Position := ACurrent;
    if not Visible then begin
      Show;
      SetFocus;
    end;
    Application.ProcessMessages;
    AFinish := Cancel;
    Cancel := false;
  end;
end;

procedure TdmMain.mtrClientAfterExecute(Sender: TObject);
begin
  if fmProgress.Visible then fmProgress.Close;
end;

end.
